//---------------------------------------------------------------------------
#ifndef TScanComparerH
#define TScanComparerH
#include <Classes.hpp>
class THasher;
class TScanRecord;
//---------------------------------------------------------------------------
class TScanComparer : public TObject
{
private:
	__fastcall TScanComparer(const TScanComparer& ASrc);
	TScanComparer& __fastcall operator=(const TScanComparer& ASrc);
protected:
public:
	__fastcall TScanComparer();
	virtual __fastcall ~TScanComparer();
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2, int ADefault) = 0;
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanBaseNameComparer : public TScanComparer
{
private:
	bool __fastcall EnsureRecord(TScanRecord* ARecord) const;
protected:
public:
	__fastcall TScanBaseNameComparer();
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2, int ADefault);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanSizeComparer : public TScanComparer
{
private:
	bool __fastcall EnsureRecord(TScanRecord* ARecord) const;
protected:
public:
	__fastcall TScanSizeComparer();
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2, int ADefault);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanTypeComparer : public TScanComparer
{
private:
	bool __fastcall EnsureRecord(TScanRecord* ARecord) const;
protected:
public:
	__fastcall TScanTypeComparer();
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2, int ADefault);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanModificationTimeComparer : public TScanComparer
{
private:
	bool __fastcall EnsureRecord(TScanRecord* ARecord) const;
protected:
public:
	__fastcall TScanModificationTimeComparer();
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2, int ADefault);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanHashComparer : public TScanComparer
{
public:
	typedef void __fastcall (__closure* THashEvent)(TObject* ASender,
		AnsiString AFileName, AnsiString& AHash, bool& ASucceeded);
private:
	THashEvent FOnHash;
	bool __fastcall EnsureRecord(TScanRecord* ARecord);
protected:
	virtual bool __fastcall DoHash(AnsiString AFileName, AnsiString& AHash);
public:
	__fastcall TScanHashComparer();
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2, int ADefault);
	__property THashEvent OnHash = {read=FOnHash, write=FOnHash};
};
//---------------------------------------------------------------------------
#endif

