//---------------------------------------------------------------------------
#ifndef TScanFieldH
#define TScanFieldH
#include <Classes.hpp>
#include "TTypedList.h"
#include "TVirtualListView.h"
class TScanRecord;
//---------------------------------------------------------------------------
class TScanField
{
private:
	int FPriority;
	AnsiString FCaption;
	TAlignment FAlignment;
	TMenuItem* FSortMenuItem;
	TMenuItem* FViewMenuItem;
	TTypedList<TVirtualListView>* FListViews;
	static int __fastcall CompareScanFieldByPriority(void* AItem1,
		void* AItem2, void* AData);
	__fastcall TScanField(const TScanField& ASrc);
	TScanField& __fastcall operator=(const TScanField& ASrc);
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	bool __fastcall GetVisible();
	void __fastcall SetVisible(bool AVisible);
protected:
public:
	__fastcall TScanField();
	virtual __fastcall ~TScanField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord) = 0;
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2) = 0;
	__property int Priority = {read=FPriority, write=FPriority};
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property TAlignment Alignment = {read=FAlignment, write=FAlignment};
	__property TMenuItem* SortMenuItem = {read=FSortMenuItem,
		write=FSortMenuItem};
	__property TMenuItem* ViewMenuItem = {read=FViewMenuItem,
		write=FViewMenuItem};
	__property TTypedList<TVirtualListView>* ListViews = {read=FListViews};
	__property bool Visible = {read=GetVisible, write=SetVisible};
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanBaseNameField : public TScanField
{
private:
protected:
public:
	__fastcall TScanBaseNameField();
	virtual __fastcall ~TScanBaseNameField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanDirectoryField : public TScanField
{
private:
protected:
public:
	__fastcall TScanDirectoryField();
	virtual __fastcall ~TScanDirectoryField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanSizeField : public TScanField
{
private:
protected:
public:
	__fastcall TScanSizeField();
	virtual __fastcall ~TScanSizeField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanTypeField : public TScanField
{
private:
protected:
public:
	__fastcall TScanTypeField();
	virtual __fastcall ~TScanTypeField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanModificationTimeField : public TScanField
{
private:
protected:
public:
	__fastcall TScanModificationTimeField();
	virtual __fastcall ~TScanModificationTimeField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanHashField : public TScanField
{
private:
protected:
public:
	__fastcall TScanHashField();
	virtual __fastcall ~TScanHashField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanPrimaryField : public TScanField
{
private:
protected:
public:
	__fastcall TScanPrimaryField();
	virtual __fastcall ~TScanPrimaryField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanGroupField : public TScanField
{
private:
protected:
public:
	__fastcall TScanGroupField();
	virtual __fastcall ~TScanGroupField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TScanErrorField : public TScanField
{
private:
protected:
public:
	__fastcall TScanErrorField();
	virtual __fastcall ~TScanErrorField();
	virtual AnsiString __fastcall DescribeRecord(TScanRecord* ARecord);
	virtual int __fastcall CompareRecord(TScanRecord* ARecord1,
		TScanRecord* ARecord2);
};
//---------------------------------------------------------------------------
#endif

