//---------------------------------------------------------------------------
#ifndef TScanFileFilterH
#define TScanFileFilterH
#include <Classes.hpp>
#include "TFileFilter.h"
#include "TScanOptions.h"
#include "TTypedList.h"
//---------------------------------------------------------------------------
class TScanFileFilter : public TObject
{
public:
	static const char FILE_EXTENSION_DELIMITER;
private:
	TTypedList<TFileFilter>* FFileFilters;
	void __fastcall Initialize(TScanOptions AOptions);
	void __fastcall Uninitialize();
	TFileExtensionFilter* __fastcall MakeFileExtensionFilter(
		AnsiString AFileExtensions, bool AInclusive) const;
	AnsiString __fastcall IncludeLeadingChar(AnsiString AString,
		char AChar) const;
	TFileAttributeFilter* __fastcall MakeFileAttributeFilter(
		DWORD AFileAttributes, bool AInclusive) const;
	__property TTypedList<TFileFilter>* FileFilters = {read=FFileFilters};
protected:
public:
	__fastcall TScanFileFilter(TScanOptions AOptions);
	virtual __fastcall ~TScanFileFilter();
	virtual bool __fastcall Passes(const WIN32_FIND_DATA& AFindData);
};
//---------------------------------------------------------------------------
#endif

