//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TScanListField.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TScanListField
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
void __fastcall TScanListField::Initialize()
{
	try {
		FValidListViews = new TTypedList<TVirtualListView>(false);
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TScanListField::Uninitialize()
{
	delete FValidListViews;
}
//---------------------------------------------------------------------------
void __fastcall TScanListField::View(TVirtualListView* AListView, bool AVisible)
{
	for(;;) {
		if(!AVisible) {
			AListView->Fields->Remove(this);
			break;
		}
		if(AListView->Fields->Find(this) >= 0) {
			break;
		}
		int itemIndex = AListView->Fields->Count;
		for(int i = 0; i < AListView->Fields->Count; i++) {
			if(static_cast<TScanListField*>(AListView->Fields->Items[i])->Kind > Kind) {
				itemIndex = i;
				break;
			}
		}
		AListView->Fields->Insert(itemIndex, this);
		break;
	}
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TScanListField::TScanListField(int AKind) :
	FKind(AKind),
	FCaption(),
	FAlignment(taLeftJustify),
	FSortMenuItem(NULL),
	FViewMenuItem(NULL),
	FValidListViews(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TScanListField::TScanListField(const TScanListField& ASrc) :
	FKind(0),
	FCaption(),
	FAlignment(taLeftJustify),
	FSortMenuItem(NULL),
	FViewMenuItem(NULL),
	FValidListViews(NULL)
{
	Initialize();
	*this = ASrc;
}
//---------------------------------------------------------------------------
__fastcall TScanListField::~TScanListField()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
TScanListField& __fastcall TScanListField::operator=(const TScanListField& ASrc)
{
	if(&ASrc != this) {
		FKind = ASrc.FKind;
		FCaption = ASrc.FCaption;
		FAlignment = ASrc.FAlignment;
		FSortMenuItem = ASrc.FSortMenuItem;
		FViewMenuItem = ASrc.FViewMenuItem;
		FValidListViews->Assign(ASrc.FValidListViews);
	}
	return *this;
}
//---------------------------------------------------------------------------
void __fastcall TScanListField::View(bool AVisible)
{
	for(int i = 0; i < ValidListViews->Count; i++) {
		View(ValidListViews->Items[i], AVisible);
	}
}
//---------------------------------------------------------------------------

