//---------------------------------------------------------------------------
#ifndef TScanListFieldH
#define TScanListFieldH
#include <Classes.hpp>
#include "TTypedList.h"
#include "TVirtualListView.h"
//---------------------------------------------------------------------------
class TScanListField
{
public:
	enum
	{
		KIND_NAME = 0,
		KIND_DIRECTORY,
		KIND_SIZE,
		KIND_TYPE,
		KIND_LAST_MODIFIED,
		KIND_HASH,
		KIND_PRIORITY,
		KIND_GROUP,
		KIND_ERROR,
	};
private:
	int FKind;
	AnsiString FCaption;
	TAlignment FAlignment;
	TMenuItem* FSortMenuItem;
	TMenuItem* FViewMenuItem;
	TTypedList<TVirtualListView>* FValidListViews;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void __fastcall View(TVirtualListView* AListView, bool AVisible);
public:
	__fastcall TScanListField(int AKind);
	__fastcall TScanListField(const TScanListField& ASrc);
	virtual __fastcall ~TScanListField();
	TScanListField& __fastcall operator=(const TScanListField& ASrc);
	virtual void __fastcall View(bool AVisible);
	__property int Kind = {read=FKind, write=FKind};
	__property AnsiString Caption = {read=FCaption, write=FCaption};
	__property TAlignment Alignment = {read=FAlignment, write=FAlignment};
	__property TMenuItem* SortMenuItem = {read=FSortMenuItem, write=FSortMenuItem};
	__property TMenuItem* ViewMenuItem = {read=FViewMenuItem, write=FViewMenuItem};
	__property TTypedList<TVirtualListView>* ValidListViews = {read=FValidListViews};
};
//---------------------------------------------------------------------------
#endif
