//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TScanRecord.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TScanRecord
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
AnsiString __fastcall TScanRecord::GetFullName() const
{
	return IncludeTrailingPathDelimiter(Directory) + BaseName;
}
//---------------------------------------------------------------------------
void __fastcall TScanRecord::SetFullName(AnsiString AFullName)
{
	Directory = ExtractFileDir(AFullName);
	BaseName = ExtractFileName(AFullName);
}
//---------------------------------------------------------------------------
FILETIME __fastcall TScanRecord::MakeFileTime(DWORD ALow, DWORD AHigh) const
{
	FILETIME fileTime;
	fileTime.dwLowDateTime = ALow;
	fileTime.dwHighDateTime = AHigh;
	return fileTime;
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TScanRecord::TScanRecord() :
	FDirectory(),
	FBaseName(),
	FSize(0),
	FType(),
	FModificationTime(MakeFileTime(0, 0)),
	FHash(),
	FPrimary(false),
	FGroup(-1),
	FError(ERROR_NONE)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TScanRecord::TScanRecord(AnsiString AFullName) :
	FDirectory(),
	FBaseName(),
	FSize(0),
	FType(),
	FModificationTime(MakeFileTime(0, 0)),
	FHash(),
	FPrimary(false),
	FGroup(-1),
	FError(ERROR_NONE)
{
	FullName = AFullName;
}
//---------------------------------------------------------------------------
__fastcall TScanRecord::TScanRecord(const TScanRecord& ASrc) :
	FDirectory(),
	FBaseName(),
	FSize(0),
	FType(),
	FModificationTime(MakeFileTime(0, 0)),
	FHash(),
	FPrimary(false),
	FGroup(-1),
	FError(ERROR_NONE)
{
	*this = ASrc;
}
//---------------------------------------------------------------------------
__fastcall TScanRecord::~TScanRecord()
{
	// Do nothing
}
//---------------------------------------------------------------------------
TScanRecord& __fastcall TScanRecord::operator=(const TScanRecord& ASrc)
{
	if(&ASrc != this) {
		FDirectory = ASrc.FDirectory;
		FBaseName = ASrc.FBaseName;
		FSize = ASrc.FSize;
		FType = ASrc.FType;
		FModificationTime = ASrc.FModificationTime;
		FHash = ASrc.FHash;
		FPrimary = ASrc.FPrimary;
		FGroup = ASrc.FGroup;
		FError = ASrc.FError;
	}
	return *this;
}
//---------------------------------------------------------------------------
bool __fastcall TScanRecord::HasError() const
{
	return Error != ERROR_NONE;
}
//---------------------------------------------------------------------------

