//---------------------------------------------------------------------------
#ifndef TScanRecordH
#define TScanRecordH
#include <Classes.hpp>
#include "TTypedList.h"
//---------------------------------------------------------------------------
class TScanRecord
{
public:
	enum
	{
		ERROR_NONE = 0,
		ERROR_CANNOT_FIND,
		ERROR_ALREADY_ADDED,
		ERROR_CANNOT_GET_FILE_TYPE,
		ERROR_UNKNOWN_FILE_TYPE,
		ERROR_UNKNOWN_FILE_TIME,
		ERROR_CANNOT_GET_HASH,
	};
private:
	AnsiString FDirectory;
	AnsiString FBaseName;
	DWORDLONG FSize;
	AnsiString FType;
	FILETIME FModificationTime;
	AnsiString FHash;
	bool FPrimary;
	int FGroup;
	int FError;
	AnsiString __fastcall GetFullName() const;
	void __fastcall SetFullName(AnsiString AFullName);
	FILETIME __fastcall MakeFileTime(DWORD ALow, DWORD AHigh) const;
protected:
public:
	__fastcall TScanRecord();
	__fastcall TScanRecord(AnsiString AFullName);
	__fastcall TScanRecord(const TScanRecord& ASrc);
	virtual __fastcall ~TScanRecord();
	TScanRecord& __fastcall operator=(const TScanRecord& ASrc);
	virtual bool __fastcall HasError() const;
	__property AnsiString FullName = {read=GetFullName, write=SetFullName};
	__property AnsiString Directory = {read=FDirectory, write=FDirectory};
	__property AnsiString BaseName = {read=FBaseName, write=FBaseName};
	__property DWORDLONG Size = {read=FSize, write=FSize};
	__property AnsiString Type = {read=FType, write=FType};
	__property FILETIME ModificationTime = {read=FModificationTime,
		write=FModificationTime};
	__property AnsiString Hash = {read=FHash, write=FHash};
	__property bool Primary = {read=FPrimary, write=FPrimary};
	__property int Group = {read=FGroup, write=FGroup};
	__property int Error = {read=FError, write=FError};
};
//---------------------------------------------------------------------------
typedef TTypedList<TScanRecord> TScanRecordList;
//---------------------------------------------------------------------------
#endif

