//---------------------------------------------------------------------------
#ifndef TScanResultListerH
#define TScanResultListerH
#include <Classes.hpp>
#include "TScanComparer.h"
#include "TScanOptions.h"
#include "TScanRecord.h"
#include "TWorker.h"
class THasher;
//---------------------------------------------------------------------------
class TScanResultLister : public TWorker
{
private:
	struct TRange
	{
		int First;
		int Last;
		__fastcall TRange(int AFirst, int ALast);
	};
	static const int HASH_BUFFER_SIZE = 1024 * 64;
	TScanRecordList* FTargets;
	TScanRecordList* FDuplicate;
	TScanRecordList* FUnique;
	TScanRecordList* FError;
	TTypedList<TRange>* FRanges;
	TTypedList<TScanComparer>* FComparers;
	THasher* FHasher;
	byte* FHashBuffer;
	TScanOptions FOptions;
	void __fastcall Initialize(TScanRecordList* ATargets,
		TScanOptions AOptions);
	void __fastcall Uninitialize();
	bool __fastcall ListNext();
	int __fastcall FindPivot(TRange ARange);
	void __fastcall AddResults(TRange ARange, TScanRecordList* AResults);
	int __fastcall CompareScanRecord(TScanRecord* AScanRecord1,
		TScanRecord* AScanRecord2, int ADefault);
	void __fastcall ScanHashComparerHash(TObject* ASender,
		AnsiString AFileName, AnsiString& AHash, bool& ASucceeded);
	THasher* __fastcall MakeHasher(int AHashAlgorithm) const;
	__property TScanRecordList* Targets = {read=FTargets};
	__property TScanRecordList* Duplicate = {read=FDuplicate};
	__property TScanRecordList* Unique = {read=FUnique};
	__property TScanRecordList* Error = {read=FError};
	__property TTypedList<TRange>* Ranges = {read=FRanges};
	__property TTypedList<TScanComparer>* Comparers = {read=FComparers};
	__property THasher* Hasher = {read=FHasher};
	__property byte* HashBuffer = {read=FHashBuffer};
protected:
public:
	__fastcall TScanResultLister(TScanRecordList* ATargets,
		TScanOptions AOptions);
	virtual __fastcall ~TScanResultLister();
	virtual void __fastcall List(TScanRecordList* ADuplicate,
		TScanRecordList* AUnique, TScanRecordList* AError);
};
//---------------------------------------------------------------------------
#endif

