//---------------------------------------------------------------------------
#ifndef TScanTargetListerH
#define TScanTargetListerH
#include <Classes.hpp>
#include "TScanOptions.h"
#include "TScanRecord.h"
#include "TWorker.h"
class TFileNameList;
class TFileTypeList;
class TScanFileFilter;
//---------------------------------------------------------------------------
class TScanTargetLister : public TWorker
{
private:
	TScanRecordList* FSrcRecords;
	TScanRecordList* FDstRecords;
	TScanFileFilter* FFileFilter;
	TFileNameList* FFileHistory;
	TFileTypeList* FFileTypes;
	void __fastcall Initialize(TScanRecordList* ASrcRecords,
		TScanOptions AOptions);
	void __fastcall Uninitialize();
	bool __fastcall ListNext();
	TScanRecord __fastcall MakeRecord(AnsiString AFullName,
		const WIN32_FIND_DATA* AFindData, bool APrimary, int AError) const;
	__property TScanRecordList* SrcRecords = {read=FSrcRecords};
	__property TScanRecordList* DstRecords = {read=FDstRecords};
	__property TScanFileFilter* FileFilter = {read=FFileFilter};
	__property TFileNameList* FileHistory = {read=FFileHistory};
	__property TFileTypeList* FileTypes = {read=FFileTypes};
	__property TProgressEvent OnProgress = {};
protected:
public:
	__fastcall TScanTargetLister(TScanRecordList* ASrcRecords,
		TScanOptions AOptions);
	virtual __fastcall ~TScanTargetLister();
	virtual void __fastcall List(TScanRecordList* ADstRecords);
};
//---------------------------------------------------------------------------
#endif

