//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TFileEnumerator.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TFileEnumerator
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
void __fastcall TFileEnumerator::FindFirst(AnsiString AFindPattern)
{
	for(;;) {
		ZeroMemory(&FFindData, sizeof(WIN32_FIND_DATA));
		FFindHandle = FindFirstFile(AFindPattern.c_str(), &FFindData);
		if(FindHandle == INVALID_HANDLE_VALUE) {
			FFindHandle = NULL;
			if(!FindRootDir(AFindPattern)) {
				Finish();
				break;
			}
		}
		break;
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFileEnumerator::FindRootDir(AnsiString AFindPattern)
{
	bool succeeded = false;
	for(;;) {
		// Determine the root directory exists
		{
			const UINT DRIVE_NOT_FOUND = 1;
			if(GetDriveType(AFindPattern.c_str()) == DRIVE_NOT_FOUND) {
				break;
			}
		}

		// Update the find data
		ZeroMemory(&FFindData, sizeof(WIN32_FIND_DATA));
		FFindData.dwFileAttributes = GetFileAttributes(AFindPattern.c_str());
		if(FFindData.dwFileAttributes == 0xFFFFFFFF) {
			break;
		}

		succeeded = true;
		break;
	}
	return succeeded;
}
//---------------------------------------------------------------------------
void __fastcall TFileEnumerator::FindNext()
{
	ZeroMemory(&FFindData, sizeof(WIN32_FIND_DATA));
	if(!FindNextFile(FindHandle, &FFindData)) {
		Finish();
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileEnumerator::Finish()
{
	FCompleted = true;
	if(FFindHandle != NULL) {
		FindClose(FFindHandle);
		FFindHandle = NULL;
	}
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TFileEnumerator::TFileEnumerator(AnsiString AFindPattern) :
	FFindHandle(NULL),
	FFindData(),
	FCompleted(false)
{
	FindFirst(AFindPattern);
}
//---------------------------------------------------------------------------
__fastcall TFileEnumerator::~TFileEnumerator()
{
	if(!Completed) {
		Finish();
	}
}
//---------------------------------------------------------------------------
bool __fastcall TFileEnumerator::HasNext() const
{
	return !Completed;
}
//---------------------------------------------------------------------------
WIN32_FIND_DATA __fastcall TFileEnumerator::GetNext()
{
	WIN32_FIND_DATA next = FindData;
	FindNext();
	return next;
}
//---------------------------------------------------------------------------

