//---------------------------------------------------------------------------
#ifndef TFileOperatorH
#define TFileOperatorH
#include <Classes.hpp>
//---------------------------------------------------------------------------
class TFileOperator
{
private:
	HWND FParent;
	bool FAllowUndo;
	bool FShowConfirmation;
	bool FConfirmMakeDir;
	bool FAllowRename;
	bool FShowProgress;
	__fastcall TFileOperator(const TFileOperator& ASrc);
	TFileOperator& __fastcall operator=(const TFileOperator& ASrc);
	void __fastcall DoubleNullTerminateStrings(TMemoryStream* AStream,
		TStrings* AStrings) const;
	bool __fastcall OperateFiles(UINT AOperation, TStrings* ASrcFiles,
		TStrings* ADstFiles) const;
protected:
public:
	__fastcall TFileOperator();
	virtual __fastcall ~TFileOperator();
	virtual bool __fastcall CopyFiles(TStrings* ASrcFiles,
		TStrings* ADstFiles) const;
	virtual bool __fastcall MoveFiles(TStrings* ASrcFiles,
		TStrings* ADstFiles) const;
	virtual bool __fastcall DeleteFiles(TStrings* AFiles) const;
	virtual bool __fastcall RenameFiles(TStrings* ASrcFiles,
		TStrings* ADstFiles) const;
	__property HWND Parent = {read=FParent, write=FParent};
	__property bool AllowUndo = {read=FAllowUndo, write=FAllowUndo};
	__property bool ShowConfirmation = {read=FShowConfirmation,
		write=FShowConfirmation};
	__property bool ConfirmMakeDir = {read=FConfirmMakeDir,
		write=FConfirmMakeDir};
	__property bool AllowRename = {read=FAllowRename, write=FAllowRename};
	__property bool ShowProgress = {read=FShowProgress, write=FShowProgress};
};
//---------------------------------------------------------------------------
#endif

