//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TFileTypeList.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TFileTypeList : public TObject
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
int __fastcall TFileTypeList::TFileExtensionList::CompareStrings(
	const AnsiString S1, const AnsiString S2)
{
	return AnsiCompareFileName(S1, S2);
}
//---------------------------------------------------------------------------
__fastcall TFileTypeList::TFileExtensionList::TFileExtensionList() :
	TStringList()
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TFileTypeList::TFileType::TFileType(AnsiString AValue) :
	FValue(AValue)
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TFileTypeList::Initialize()
{
	try {
		FFileExtensions = new TFileExtensionList();
		FFileExtensions->Duplicates = dupIgnore;
		FFileExtensions->Sorted = true;
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TFileTypeList::Uninitialize()
{
	if(FFileExtensions != NULL) {
		Clear();
		delete FFileExtensions;
	}
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFileTypeList::GetItem(AnsiString AFileName) const
{
	AnsiString item;
	for(;;) {
		AnsiString fileExtension;
		{
			DWORD fileAttributes = GetFileAttributes(AFileName.c_str());
			if(fileAttributes == 0xFFFFFFFF) {
				break;
			}
			if((fileAttributes & FILE_ATTRIBUTE_DIRECTORY) != 0) {
				fileExtension = AnsiString();
			}
			else {
				fileExtension = ExtractFileExt(AFileName);
			}
		}
		int itemIndex;
		if(!FileExtensions->Find(fileExtension, itemIndex)) {
			AnsiString fileType = GetFileType(AFileName);
			if(fileType.Length() == 0) {
				break;
			}
			itemIndex = FileExtensions->AddObject(fileExtension,
				new TFileType(fileType));
		}
		item = dynamic_cast<TFileType*>(
			FileExtensions->Objects[itemIndex])->Value;
		break;
	}
	return item;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TFileTypeList::GetFileType(AnsiString AFileName) const
{
	AnsiString fileType;
	for(;;) {
		SHFILEINFO fileInfo;
		ZeroMemory(&fileInfo, sizeof(SHFILEINFO));
		if(!SHGetFileInfo(
				AFileName.c_str(),
				0,
				&fileInfo,
				sizeof(SHFILEINFO),
				SHGFI_TYPENAME)) {
			break;
		}
		fileType = fileInfo.szTypeName;
		break;
	}
	return fileType;
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TFileTypeList::TFileTypeList() :
	TObject(),
	FFileExtensions(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TFileTypeList::~TFileTypeList()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TFileTypeList::Clear()
{
	for(int i = 0; i < FileExtensions->Count; i++) {
		delete dynamic_cast<TFileType*>(FileExtensions->Objects[i]);
	}
	FileExtensions->Clear();
}
//---------------------------------------------------------------------------

