//---------------------------------------------------------------------------
#ifndef TShortCutFileH
#define TShortCutFileH
#include <Classes.hpp>
//---------------------------------------------------------------------------
class EShortCutFileError : public Exception
{
private:
protected:
public:
	__fastcall EShortCutFileError(AnsiString AMessage);
	virtual __fastcall ~EShortCutFileError();
};
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
class TShortCutFile
{
private:
	AnsiString FFileName;
	IShellLink* FShellLink;
	IPersistFile* FPersistFile;
	void __fastcall Initialize();
	void __fastcall InitializeInterface();
	void __fastcall Uninitialize();
	void __fastcall UninitializeInterface();
	AnsiString __fastcall GetArguments() const;
	void __fastcall SetArguments(AnsiString AArguments);
	AnsiString __fastcall GetDescription() const;
	void __fastcall SetDescription(AnsiString ADescription);
	WORD __fastcall GetHotKey() const;
	void __fastcall SetHotKey(WORD AHotKey);
	AnsiString __fastcall GetIconFile() const;
	void __fastcall SetIconFile(AnsiString AIconFile);
	int __fastcall GetIconIndex() const;
	void __fastcall SetIconIndex(int AIconIndex);
	AnsiString __fastcall GetTarget() const;
	void __fastcall SetTarget(AnsiString ATarget);
	int __fastcall GetShowCommand() const;
	void __fastcall SetShowCommand(int AShowCommand);
	AnsiString __fastcall GetWorkingDirectory() const;
	void __fastcall SetWorkingDirectory(AnsiString AWorkingDirectory);
protected:
	virtual void __fastcall Load(AnsiString AFileName);
	virtual void __fastcall Save(AnsiString AFileName) const;
	virtual void __fastcall ReadFail() const;
	virtual void __fastcall WriteFail() const;
public:
	__fastcall TShortCutFile();
	__fastcall TShortCutFile(AnsiString AFileName);
	__fastcall TShortCutFile(const TShortCutFile& ASrc);
	virtual __fastcall ~TShortCutFile();
	TShortCutFile& __fastcall operator=(const TShortCutFile& ASrc);
	void __fastcall UpdateFile() const;
	__property AnsiString FileName = {read=FFileName, write=FFileName};
	__property AnsiString Arguments = {read=GetArguments,
		write=SetArguments};
	__property AnsiString Description = {read=GetDescription,
		write=SetDescription};
	__property WORD HotKey = {read=GetHotKey, write=SetHotKey};
	__property AnsiString IconFile = {read=GetIconFile, write=SetIconFile};
	__property int IconIndex = {read=GetIconIndex, write=SetIconIndex};
	__property int ShowCommand = {read=GetShowCommand, write=SetShowCommand};
	__property AnsiString Target = {read=GetTarget, write=SetTarget};
	__property AnsiString WorkingDirectory = {read=GetWorkingDirectory,
		write=SetWorkingDirectory};
	__property IShellLink* ShellLink = {read=FShellLink};
	__property IPersistFile* PersistFile = {read=FPersistFile};
};
//---------------------------------------------------------------------------
#endif

