//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TStringTokenizer.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TStringTokenizer
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
bool __fastcall TStringTokenizer::IsDelimiter(const char* AStringPos)
{
	bool matched = false;
	const char* delimiterPos = Delimiters.c_str();
	for(;;) {
		if(*delimiterPos == '\0') {
			break;
		}
		if(AnsiStrLComp(
				const_cast<char*>(AStringPos),
				const_cast<char*>(delimiterPos),
				IsDBCSLeadByte(*AStringPos) ? 2 : 1) == 0) {
			matched = true;
			break;
		}
		delimiterPos = CharNext(delimiterPos);
	}
	return matched;
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TStringTokenizer::TStringTokenizer(AnsiString AString,
		AnsiString ADelimiters) :
	FString(AString),
	FDelimiters(ADelimiters),
	FTokenStart(AString.c_str())
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TStringTokenizer::~TStringTokenizer()
{
	// Do nothing
}
//---------------------------------------------------------------------------
bool __fastcall TStringTokenizer::HasNext() const
{
	return TokenStart != NULL;
}
//---------------------------------------------------------------------------
AnsiString __fastcall TStringTokenizer::GetNext()
{
	const char* tokenEnd = TokenStart;
	while(*tokenEnd != '\0' && !IsDelimiter(tokenEnd)) {
		tokenEnd = CharNext(tokenEnd);
	}
	AnsiString token = AnsiString(TokenStart, tokenEnd - TokenStart);
	TokenStart = *tokenEnd == '\0' ?
		NULL :
		CharNext(tokenEnd);
	return token;
}
//---------------------------------------------------------------------------

