//---------------------------------------------------------------------------
#ifndef TTextFindDialogH
#define TTextFindDialogH
//---------------------------------------------------------------------------
#include <vcl\ExtCtrls.hpp>
#include <vcl\Buttons.hpp>
#include <vcl\StdCtrls.hpp>
#include <vcl\Controls.hpp>
#include <vcl\Forms.hpp>
#include <vcl\Graphics.hpp>
#include <vcl\Classes.hpp>
#include <vcl\SysUtils.hpp>
#include <vcl\Windows.hpp>
#include <vcl\System.hpp>
//---------------------------------------------------------------------------
class TTextFindDialog : public TForm
{
__published:
	TButton* Button1;
	TButton* Button2;
	TCheckBox* CheckBox1;
	TCheckBox* CheckBox2;
	TEdit* Edit1;
	TLabel* Label1;
	TRadioGroup* RadioGroup1;
	void __fastcall TextFindDialogShow(TObject* ASender);
	void __fastcall TextFindDialogHide(TObject* ASender);
	void __fastcall Edit1Change(TObject* ASender);
private:
	struct TBackup
	{
		AnsiString FindText;
		TFindOptions Options;
	};
	TBackup* FBackup;
	void __fastcall MakeBackup();
	void __fastcall FreeBackup();
	void __fastcall Reset();
	AnsiString __fastcall GetFindText();
	void __fastcall SetFindText(AnsiString AFindText);
	TFindOptions __fastcall GetOptions();
	void __fastcall SetOptions(TFindOptions AOptions);
	void __fastcall Change();
	bool __fastcall IsResultAccept(TModalResult AResult) const;
	__property TBackup* Backup = {read=FBackup};
protected:
public:
	virtual __fastcall TTextFindDialog(TComponent* AOwner);
	virtual __fastcall ~TTextFindDialog();
	virtual bool __fastcall Execute();
	__property AnsiString FindText = {read=GetFindText, write=SetFindText};
	__property TFindOptions Options = {read=GetOptions, write=SetOptions};
};
//---------------------------------------------------------------------------
extern PACKAGE TTextFindDialog* TextFindDialog;
//---------------------------------------------------------------------------
#endif

