//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TVirtualListFields.h"
#include "TVirtualListView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TVirtualListFields : public TVirtualListParams
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TVirtualListFields::TVirtualListFields(
		TVirtualListView* AListView) :
	TVirtualListParams(AListView)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TVirtualListFields::~TVirtualListFields()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListFields::InsertItems(int AIndex, TList* AItems)
{
	for(int i = 0; i < AItems->Count; i++) {
		int itemIndex = AIndex + i;
		List->Insert(itemIndex, AItems->Items[i]);
		ListView->Columns->Insert(itemIndex);

		// Reset indexes of the columns
		ListView->Columns->Delete(ListView->Columns->Add()->Index);

		DoAdd(Items[itemIndex]);
	}
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListFields::DeleteItems(TIntegerDynArray AIndexes)
{
	TBooleanDynArray canDelete = IndexesToTable(AIndexes);
	for(int i = 0; i < canDelete.Length; i++) {
		int itemIndex = canDelete.Length - 1 - i;
		if(canDelete[itemIndex]) {
			DoDelete(Items[itemIndex]);
			ListView->Columns->Delete(itemIndex);
			List->Delete(itemIndex);
		}
	}
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListFields::Reorder(TIntegerDynArray AOrder)
{
	struct TReorderItem
	{
		void* Item;
		TListColumn* Column;
	};

	TList* reorderItems = NULL;
	try {
		reorderItems = new TList();
		reorderItems->Count = AOrder.Length;
		for(int i = 0; i < AOrder.Length; i++) {
			int srcIndex = AOrder[i];
			int dstIndex = i;
			if(srcIndex != dstIndex) {
				TReorderItem reorderItem = {
					List->Items[srcIndex],
					ListView->Columns->Items[srcIndex]
				};
				reorderItems->Items[dstIndex] =
					new TReorderItem(reorderItem);
			}
			for(int i = 0; i < reorderItems->Count; i++) {
				if(reorderItems->Items[i] != NULL) {
					TReorderItem* reorderItem =
						static_cast<TReorderItem*>(reorderItems->Items[i]);
					List->Items[srcIndex] = reorderItem->Item;
					reorderItem->Column->Index = i;
				}
			}
		}
	}
	__finally {
		for(int i = 0; i < reorderItems->Count; i++) {
			delete static_cast<TReorderItem*>(reorderItems->Items[i]);
		}
		delete reorderItems;
	}
	DoChange();
}
//---------------------------------------------------------------------------

