//---------------------------------------------------------------------------
#ifndef TVirtualListParamsH
#define TVirtualListParamsH
#include <Classes.hpp>
class TVirtualListView;
//---------------------------------------------------------------------------
class TVirtualListParams : public TObject
{
public:
	typedef void __fastcall (__closure* TExpandEvent)(TObject* ASender,
		void* AItem);
	typedef int __fastcall (* TSortCompare)(void* AItem1, void* AItem2,
		void* AData);
private:
	TVirtualListView* FListView;
	TList* FList;
	TExpandEvent FOnAdd;
	TExpandEvent FOnDelete;
	TNotifyEvent FOnChange;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	void* __fastcall GetItem(int AIndex) const;
	void __fastcall SetItem(int AIndex, void* AItem);
	int __fastcall GetCount() const;
protected:
	virtual void __fastcall DoAdd(void* AItem);
	virtual void __fastcall DoDelete(void* AItem);
	virtual void __fastcall DoChange();
	TIntegerDynArray __fastcall GetAllIndexes() const;
	TIntegerDynArray __fastcall GetSelIndexes() const;
	TIntegerDynArray __fastcall InvertIndexes(
		TIntegerDynArray AIndexes) const;
	TBooleanDynArray __fastcall IndexesToTable(
		TIntegerDynArray AIndexes) const;
	__property TList* List = {read=FList};
public:
	__fastcall TVirtualListParams(TVirtualListView* AListView);
	virtual __fastcall ~TVirtualListParams();
	virtual int __fastcall Add(void* AItem);
	virtual void __fastcall AddItems(TList* AItems);
	virtual void __fastcall Insert(int AIndex, void* AItem);
	virtual void __fastcall InsertItems(int AIndex, TList* AItems) = 0;
	virtual int __fastcall Remove(void* AItem);
	virtual void __fastcall RemoveItems(TList* AItems);
	virtual void __fastcall Delete(int AIndex);
	virtual void __fastcall DeleteItems(TIntegerDynArray AIndexes) = 0;
	virtual void __fastcall Clear();
	virtual void __fastcall Sort(TSortCompare ACompare, void* AData);
	virtual void __fastcall Invert();
	virtual void __fastcall Reorder(TIntegerDynArray AOrder) = 0;
	virtual int __fastcall Find(void* AItem) const;
	__property TVirtualListView* ListView = {read=FListView};
	__property void* Items[int AIndex] = {read=GetItem, write=SetItem};
	__property int Count = {read=GetCount};
	__property TExpandEvent OnAdd = {read=FOnAdd, write=FOnAdd};
	__property TExpandEvent OnDelete = {read=FOnDelete, write=FOnDelete};
	__property TNotifyEvent OnChange = {read=FOnChange, write=FOnChange};
};
//---------------------------------------------------------------------------
#endif

