//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TVirtualListRecords.h"
#include "TVirtualListView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TVirtualListRecords : public TVirtualListParams
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TVirtualListRecords::TVirtualListRecords(
		TVirtualListView* AListView) :
	TVirtualListParams(AListView)
{
	// Do nothing
}
//---------------------------------------------------------------------------
__fastcall TVirtualListRecords::~TVirtualListRecords()
{
	// Do nothing
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListRecords::InsertItems(int AIndex, TList* AItems)
{
	int oldCount = List->Count;
	int newCount = List->Count + AItems->Count;
	for(int step = 0; step < 2; step++) {
		if(step == 0) {
			List->Count = newCount;
		}
		else {
			ListView->Items->Count = newCount;
		}
		for(int i = 0; i < oldCount - AIndex; i++) {
			int srcIndex = oldCount - 1 - i;
			int dstIndex = newCount - 1 - i;
			if(step == 0) {
				List->Items[dstIndex] = List->Items[srcIndex];
			}
			else {
				ListView->States[dstIndex] = ListView->States[srcIndex];
			}
		}
		for(int i = 0; i < AItems->Count; i++) {
			int srcIndex = i;
			int dstIndex = oldCount + i;
			if(step == 0) {
				List->Items[dstIndex] = AItems->Items[srcIndex];
			}
			else {
				ListView->States[dstIndex] = 0;
				DoAdd(List->Items[dstIndex]);
			}
		}
	}
	ListView->Invalidate();
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListRecords::DeleteItems(TIntegerDynArray AIndexes)
{
	TBooleanDynArray canDelete = IndexesToTable(AIndexes);
	int deletionCount = 0;
	int newFocusIndex = ListView->FocusIndex;
	for(int i = 0; i < canDelete.Length; i++) {
		if(canDelete[i]) {
			DoDelete(List->Items[i]);
			deletionCount++;
			if(newFocusIndex < i) {
				newFocusIndex--;
			}
		}
		else {
			if(deletionCount > 0) {
				int srcIndex = i;
				int dstIndex = i - deletionCount;
				List->Items[dstIndex] = List->Items[srcIndex];
				ListView->States[dstIndex] = ListView->States[srcIndex];
			}
		}
	}
	int newCount = List->Count - deletionCount;
	ListView->Items->Count = newCount;
	if(newFocusIndex >= 0 && newCount > 0) {
		if(newFocusIndex >= newCount) {
			newFocusIndex = newCount - 1;
		}
		ListView->FocusIndex = newFocusIndex;
	}
	List->Count = newCount;
	ListView->Invalidate();
	DoChange();
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListRecords::DeleteSelected()
{
	DeleteItems(GetSelIndexes());
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListRecords::Reorder(TIntegerDynArray AOrder)
{
	struct TReorderItem
	{
		void* Item;
		UINT State;
	};

	TList* reorderItems = NULL;
	try {
		reorderItems = new TList();
		reorderItems->Count = AOrder.Length;
		for(int i = 0; i < AOrder.Length; i++) {
			int srcIndex = AOrder[i];
			int dstIndex = i;
			if(srcIndex != dstIndex) {
				TReorderItem curReorderItem = {
					List->Items[srcIndex],
					ListView->States[srcIndex]
				};
				reorderItems->Items[dstIndex] =
					new TReorderItem(curReorderItem);
			}
		}
		for(int i = 0; i < AOrder.Length; i++) {
			if(reorderItems->Items[i] != NULL) {
				TReorderItem* curReorderItem =
					static_cast<TReorderItem*>(reorderItems->Items[i]);
				List->Items[i] = curReorderItem->Item;
				ListView->States[i] = curReorderItem->State;
			}
		}
	}
	__finally {
		for(int i = 0; i < AOrder.Length; i++) {
			delete static_cast<TReorderItem*>(reorderItems->Items[i]);
		}
		delete reorderItems;
	}
	ListView->Invalidate();
	DoChange();
}
//---------------------------------------------------------------------------

