//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop
#include "TVirtualListView.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
// class TVirtualListView : public TListView
//---------------------------------------------------------------------------
// private:
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::Initialize()
{
	try {
		OwnerData = true;
		FRecords = MakeRecords();
		FFields = MakeFields();
	}
	catch(...) {
		Uninitialize();
		throw;
	}
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::Uninitialize()
{
	delete FFields;
	delete FRecords;
}
//---------------------------------------------------------------------------
int __fastcall TVirtualListView::GetFocusIndex()
{
	return ItemFocused != NULL ? ItemFocused->Index : -1;
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::SetFocusIndex(int AFocusIndex)
{
	ItemFocused = AFocusIndex >= 0 ? Items->Item[AFocusIndex] : NULL;
}
//---------------------------------------------------------------------------
UINT __fastcall TVirtualListView::GetState(int AIndex)
{
	return ListView_GetItemState(Handle, AIndex,
		LVIS_CUT | LVIS_DROPHILITED | LVIS_FOCUSED | LVIS_SELECTED);
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::SetState(int AIndex, UINT AState)
{
	ListView_SetItemState(Handle, AIndex, AState,
		LVIS_CUT | LVIS_DROPHILITED | LVIS_FOCUSED | LVIS_SELECTED);
}
//---------------------------------------------------------------------------
bool __fastcall TVirtualListView::GetCut(int AIndex)
{
	return (ListView_GetItemState(Handle, AIndex, LVIS_CUT) &
		LVIS_CUT) != 0;
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::SetCut(int AIndex, bool ACut)
{
	ListView_SetItemState(Handle, AIndex, ACut ? LVIS_CUT : 0, LVIS_CUT);
}
//---------------------------------------------------------------------------
bool __fastcall TVirtualListView::GetDropTarget(int AIndex)
{
	return (ListView_GetItemState(Handle, AIndex, LVIS_DROPHILITED) &
		LVIS_DROPHILITED) != 0;
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::SetDropTarget(int AIndex, bool ADropTarget)
{
	ListView_SetItemState(Handle, AIndex, ADropTarget ? LVIS_DROPHILITED : 0,
		LVIS_DROPHILITED);
}
//---------------------------------------------------------------------------
bool __fastcall TVirtualListView::GetFocused(int AIndex)
{
	return (ListView_GetItemState(Handle, AIndex, LVIS_FOCUSED) &
		LVIS_FOCUSED) != 0;
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::SetFocused(int AIndex, bool AFocused)
{
	ListView_SetItemState(Handle, AIndex, AFocused ? LVIS_FOCUSED : 0,
		LVIS_FOCUSED);
}
//---------------------------------------------------------------------------
bool __fastcall TVirtualListView::GetSelected(int AIndex)
{
	return (ListView_GetItemState(Handle, AIndex, LVIS_SELECTED) &
		LVIS_SELECTED) != 0;
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::SetSelected(int AIndex, bool ASelected)
{
	ListView_SetItemState(Handle, AIndex, ASelected ? LVIS_SELECTED : 0,
		LVIS_SELECTED);
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::WMChanged(TMessage& AMessage)
{
	DoChanged();
}
//---------------------------------------------------------------------------
// protected:
//---------------------------------------------------------------------------
TVirtualListRecords* __fastcall TVirtualListView::MakeRecords()
{
	return new TVirtualListRecords(this);
}
//---------------------------------------------------------------------------
TVirtualListFields* __fastcall TVirtualListView::MakeFields()
{
	return new TVirtualListFields(this);
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::Change(TListItem* AItem, int AChange)
{
	MSG message;
	if(!PeekMessage(&message, Handle, WM_CHANGED, WM_CHANGED, PM_NOREMOVE)) {
		PostMessage(Handle, WM_CHANGED, 0, 0);
	}
	TListView::Change(AItem, AChange);
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::DoChanged()
{
	if(OnChanged != NULL) {
		OnChanged(this);
	}
}
//---------------------------------------------------------------------------
// public:
//---------------------------------------------------------------------------
__fastcall TVirtualListView::TVirtualListView(TComponent* AOwner) :
	TListView(AOwner),
	FRecords(NULL),
	FFields(NULL),
	FOnChanged(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TVirtualListView::TVirtualListView(HWND AParentWindow) :
	TListView(AParentWindow),
	FRecords(NULL),
	FFields(NULL),
	FOnChanged(NULL)
{
	Initialize();
}
//---------------------------------------------------------------------------
__fastcall TVirtualListView::~TVirtualListView()
{
	Uninitialize();
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::MakeVisible(int AIndex, bool AAllowPartial)
{
	ListView_EnsureVisible(Handle, AIndex, AAllowPartial);
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::ReverseSelection()
{
	for(int i = 0; i < Items->Count; i++) {
		Selected[i] = !Selected[i];
	}
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::SelectItems(int AIndex, int ACount,
	bool ASelected)
{
	for(int i = 0; i < ACount; i++) {
		Selected[AIndex + i] = ASelected;
	}
}
//---------------------------------------------------------------------------
void __fastcall TVirtualListView::FitColumns()
{
	int newColumnWidth = ClientWidth <= 0 ?
		0 :
		(ClientWidth / Columns->Count);
	for(int i = 0; i < Columns->Count; i++) {
		Columns->Items[i]->Width = newColumnWidth;
	}
}
//---------------------------------------------------------------------------

