//---------------------------------------------------------------------------
#ifndef TVirtualListViewH
#define TVirtualListViewH
#include <Classes.hpp>
#include <ComCtrls.hpp>
#include "TVirtualListRecords.h"
#include "TVirtualListFields.h"
//---------------------------------------------------------------------------
class TVirtualListView : public TListView
{
private:
	static const UINT WM_CHANGED = WM_APP + 0;
	TVirtualListRecords* FRecords;
	TVirtualListFields* FFields;
	TNotifyEvent FOnChanged;
	void __fastcall Initialize();
	void __fastcall Uninitialize();
	int __fastcall GetFocusIndex();
	void __fastcall SetFocusIndex(int AFocusIndex);
	UINT __fastcall GetState(int AIndex);
	void __fastcall SetState(int AIndex, UINT AState);
	bool __fastcall GetCut(int AIndex);
	void __fastcall SetCut(int AIndex, bool ACut);
	bool __fastcall GetDropTarget(int AIndex);
	void __fastcall SetDropTarget(int AIndex, bool ADropTarget);
	bool __fastcall GetFocused(int AIndex);
	void __fastcall SetFocused(int AIndex, bool AFocused);
	bool __fastcall GetSelected(int AIndex);
	void __fastcall SetSelected(int AIndex, bool ASelected);
	void __fastcall WMChanged(TMessage& AMessage);
protected:
	virtual TVirtualListRecords* __fastcall MakeRecords();
	virtual TVirtualListFields* __fastcall MakeFields();
	DYNAMIC void __fastcall Change(TListItem* AItem, int AChange);
	virtual void __fastcall DoChanged();
public:
	__fastcall TVirtualListView(TComponent* AOwner);
	__fastcall TVirtualListView(HWND AParentWindow);
	virtual __fastcall ~TVirtualListView();
	virtual void __fastcall MakeVisible(int AIndex, bool AAllowPartial);
	virtual void __fastcall ReverseSelection();
	virtual void __fastcall SelectItems(int AIndex, int ACount,
		bool ASelected);
	virtual void __fastcall FitColumns();
	BEGIN_MESSAGE_MAP
		MESSAGE_HANDLER(WM_CHANGED, TMessage, WMChanged)
	END_MESSAGE_MAP(TListView)
	__property TVirtualListRecords* Records = {read=FRecords};
	__property TVirtualListFields* Fields = {read=FFields};
	__property int FocusIndex = {read=GetFocusIndex, write=SetFocusIndex};
	__property UINT States[int AIndex] = {read=GetState, write=SetState};
	__property bool Cut[int AIndex] = {read=GetCut, write=SetCut};
	__property bool DropTarget[int AIndex] = {read=GetDropTarget,
		write=SetDropTarget};
	__property bool Focused[int AIndex] = {read=GetFocused,
		write=SetFocused};
	__property bool Selected[int AIndex] = {read=GetSelected,
		write=SetSelected};
	__property TNotifyEvent OnChanged = {read=FOnChanged, write=FOnChanged};
};
//---------------------------------------------------------------------------
#endif

